abuild.in 45.1 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
FAKEROOT=${FAKEROOT:-"fakeroot"}
22

23 24
: ${SUDO_APK:=abuild-apk}
: ${APK:=apk}
25 26 27
: ${ADDUSER:=abuild-adduser}
: ${ADDGROUP:=abuild-addgroup}

28
apk_opt_wait="--wait 30"
29

Natanael Copa's avatar
Natanael Copa committed
30
# read config
Natanael Copa's avatar
Natanael Copa committed
31
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
32 33
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

34
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
35 36 37 38 39 40
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
41 42 43 44 45 46 47 48 49 50 51 52 53 54
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
55 56 57 58 59
fi	
	

# functions
msg() {
60
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
61 62 63
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
64 65 66 67 68 69 70
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
71 72 73 74 75 76
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
77 78 79 80 81 82
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
	#      ">>> WARNING: 
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
83 84 85 86 87 88
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
89 90 91 92 93 94
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

error2() {
	#      ">>> ERROR: 
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
95
}
Natanael Copa's avatar
Natanael Copa committed
96

Linux User's avatar
Linux User committed
97
set_xterm_title() {
98
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
99
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
100 101 102 103 104
	fi
} 

cleanup() {
	set_xterm_title ""
105
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
106
		msg "Uninstalling dependencies..."
107
		$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
108
	fi
109 110 111
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
Linux User's avatar
Linux User committed
112 113
}

Natanael Copa's avatar
Natanael Copa committed
114
die() {
Linux User's avatar
Linux User committed
115
	error "$@"
Linux User's avatar
Linux User committed
116
	cleanup
Natanael Copa's avatar
Natanael Copa committed
117 118 119
	exit 1
}

120
# check if apkbuild is basicly sane
121
default_sanitycheck() {
122
	local i= j= suggestion=
123
	msg "Checking sanity of $APKBUILD..."
124 125 126
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
127
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
128
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
129 130
			die "$pkgver is not a valid version"
	fi
131
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
132 133 134
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"
Natanael Copa's avatar
Natanael Copa committed
135 136 137
	if [ $(echo "$pkgdesc" | wc -c) -gt 128 ]; then
		die "pkgdesc is too long"
	fi
138

Natanael Copa's avatar
Natanael Copa committed
139 140
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
141 142
		die "replaces_priority must be a number"
	fi
143 144 145 146 147 148 149
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

150 151 152 153 154 155 156 157 158 159
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
160
	for i in $install; do
161
		local n=${i%.*}
162
		local suff=${i##*.}
163 164 165 166 167
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
168
			die "$i: install script does not match pkgname or any subpackage"
169
		fi
170
		[ -e "$startdir/$i" ] || die "install script $i is missing"
171 172 173 174 175 176
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
177 178
	done
	
179 180 181 182 183 184 185 186
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
		[ "$f" = "$i" ] && die "$f: triggers must contain '='" 
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
187

188 189
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
190 191
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
192 193 194 195
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
Natanael Copa's avatar
Natanael Copa committed
196
			case "$i" in
197
				*::*) i=${i%%::*};;
198
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
Natanael Copa's avatar
Natanael Copa committed
199
			esac
200 201
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
202 203
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
204

205 206 207 208 209 210 211 212
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
213
		done
214
	done
215

216 217 218
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
219 220

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
221 222

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
223 224 225
	return 0
}

226 227 228 229
sanitycheck() {
	default_sanitycheck
}

230 231
sumcheck() {
	local algo="$1" sums="$2"
232
	local dummy f endreturnval originalparams origin file
233 234 235 236 237 238 239 240

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
241
	fi
242
	fetch || return 1
243
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
244
	cd "$srcdir" || return 1
245 246
	IFS=$'\n'
	endreturnval=0
247
	for src in $sums; do
248
		origin=$1; shift
249
		echo "$src" | ${algo}sum -c
250
		if [ $? -ne 0 ]; then
251
			endreturnval=1
252
			is_remote $origin || continue
253
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
254 255 256 257 258 259 260 261
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
262 263
}

264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
	for algo in md5 sha1 sha256 sha512; do
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

Natanael Copa's avatar
Natanael Copa committed
288 289
# verify upstream sources
sourcecheck() {
290 291 292 293 294 295 296 297
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
298 299 300
		*::*)
			uri=${uri##*::}
			;;
301 302
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
303
	done
304
	return 0
Natanael Copa's avatar
Natanael Copa committed
305
}
306

307 308 309
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
310
	while getopts "C:Lko:s" opt; do
311
		case $opt in
312
		'L') ;; # --location. wget does this by default
313
		'f') ;; # --fail. wget does this by default
314 315 316 317 318 319 320 321 322 323
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
324 325
uri_fetch() {
	local uri="$1"
326
	local d="${uri##*/}"	# $(basename $uri)
327
	local opts
328
	[ -n "$quiet" ] && opts="-s"
329 330

	local lockfile="$SRCDEST/$d".lock
331

332 333 334 335 336
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
337 338 339 340 341

		*::*)
			d=${uri%%::*}
			uri=${uri#$d::}
			;;
Natanael Copa's avatar
Natanael Copa committed
342
	esac
343 344

	case "$uri" in
345
		https://*) opts="-k";;
346
	esac
347

Natanael Copa's avatar
Natanael Copa committed
348
	mkdir -p "$SRCDEST"
349 350 351

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
352 353
	flock -n -x 9 || msg "Waiting for ${lockfile##*/}..."
	flock -x 9
354 355 356

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

357 358
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
359
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
360
	fi
Linux User's avatar
Linux User committed
361
	msg "Fetching $uri"
362 363

	# fallback to wget if curl is missing. useful for bootstrapping
364
	local fetcher=
365 366
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
367 368
	else
		fetcher=curl
369
		opts="$opts -L -f -k"
370 371 372
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
373
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
374

375
	) 9>$lockfile
376 377 378 379

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
380 381
}

382
is_remote() {
383
	case "${1#*::}" in
384
		http://*|ftp://*|https://*|saveas-*://*)
385 386 387 388 389
			return 0;;
	esac
	return 1
}

390 391 392 393 394 395 396 397 398
filename_from_uri() {
	local uri="$1"
	local filename="${uri##*/}"  # $(basename $uri)
	case "$uri" in
	*::*) filename=${uri%%::*};;
	esac
	echo "$filename"
}

399 400 401 402
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	if [ -n "$DISTFILES_MIRROR" ]; then
403
		if is_remote "$DISTFILES_MIRROR"; then
404 405
			uri_fetch "$DISTFILES_MIRROR"/$(filename_from_uri $uri)\
				&& return 0
406
		else
407 408
			cp "$DISTFILES_MIRROR"/$(filename_from_uri $uri) \
				"$SRCDEST" && return 0
409
		fi
410 411 412 413
	fi
	uri_fetch "$uri"
}

414
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
415 416
	local s
	mkdir -p "$srcdir"
417 418
	for s in $source; do
		if is_remote "$s"; then
419
			uri_fetch_mirror "$s" || return 1
420
			ln -sf "$SRCDEST/$(filename_from_uri $s)" "$srcdir"/
421 422 423
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
424 425 426
	done
}

427 428 429 430
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
431 432 433 434 435 436 437 438 439 440 441 442 443 444 445
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
446
# unpack the sources
447
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
448
	local u
449
	if [ -z "$force" ]; then
450
		verify || return 1
Natanael Copa's avatar
Natanael Copa committed
451
		initdcheck || return 1
452
	fi
Natanael Copa's avatar
Natanael Copa committed
453 454
	mkdir -p "$srcdir"
	for u in $source; do
455
		local s="$SRCDEST/$(filename_from_uri $u)"
Natanael Copa's avatar
Natanael Copa committed
456
		case "$s" in
457 458 459
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
460
			*.tar.gz|*.tgz)
461
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
462 463
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
464
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
465
				tar -C "$srcdir" -jxf "$s" || return 1;;
466 467 468 469
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
470 471 472
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
473 474 475
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
476 477 478 479
		esac
	done
}

480 481 482 483
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
484 485
# cleanup source and package dir
clean() {
486
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
487
	rm -rf "$srcdir"
488
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
489 490 491 492 493 494
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
495
		if is_remote "$s"; then
496 497 498
			s=$(filename_from_uri $s)
			msg "Cleaning downloaded $s ..."
			rm -f "$SRCDEST/$s"
499
		fi
Natanael Copa's avatar
Natanael Copa committed
500 501 502
	done
}

503 504 505 506 507 508 509 510 511 512
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
513 514
cleanpkg() {
	local i
515
	getpkgver || return 1
516
	msg "Cleaning built packages..."
517
	for i in $(listpkgnames); do
518 519
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
520
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
521
	done
522
	# remove given packages from index
523
	update_abuildrepo_index
Natanael Copa's avatar
Natanael Copa committed
524 525
}

526 527 528
# clean all packages except current
cleanoldpkg() {
	local i j
529
	getpkgver || return 1
530
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
531
	for i in $(listpkgnames); do
532 533 534 535 536
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
537 538 539 540
		done
	done
	return 0
}
541 542 543

mkusers() {
	local i
544 545 546 547 548 549
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
550 551
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
552
			local gopt=
553
			msg "Creating user $i"
554 555 556
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
557
			$ADDUSER -S -D -H $gopt $i || return 1
558 559 560 561 562
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
563 564
runpart() {
	local part=$1
565
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
566 567 568 569
	$part || die "$part failed"
}

# override those in your build script
570 571 572 573 574 575 576 577
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
578 579 580 581
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
582
build() {
583
	:
Natanael Copa's avatar
Natanael Copa committed
584 585
}

586 587 588
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
589
	mkdir -p "$PKGDEST"
590 591 592
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
593 594 595 596 597 598 599 600 601
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

602 603 604
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
605
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
606 607 608 609 610 611 612 613
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
	fi
614 615 616 617 618 619 620 621 622 623 624 625 626
	# look for *.la files
	i=$(find "$dir" -name '*.la' | sed "s|^$dir|\t|")
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i"
		return 1
	fi
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
627 628 629 630 631 632 633 634 635
	# check so we dont have any suid root binaries that are not 
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
636 637 638 639 640 641 642 643 644
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
645 646 647
	return 0
}

648
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
649 650
	local i
	cd "$startdir"
651
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
652 653
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
654
		msg "Running split function $func..."
655 656
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
		subpkgdir="$dir" subpkgname="$name" \
657
			$0 $func prepare_package || return 1
658
		postcheck "$dir" "$name" || return 1
Natanael Copa's avatar
Natanael Copa committed
659
	done
660
	postcheck "$pkgdir" "$pkgname" || return 1
661 662
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
663
		warning "Found /usr/share/locale"
664
		warning2 "Maybe add \$pkgname-lang to subpackages?"
665
	fi
Natanael Copa's avatar
Natanael Copa committed
666 667
}

668
default_lang() {
669
	pkgdesc="Languages for package $pkgname"
670 671 672 673 674 675 676 677 678 679 680 681 682
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

683
default_lang_subpkg() {
684 685 686 687
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
688
	pkgdesc="$pkgname language pack for $lang"
689 690
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
691 692 693 694 695
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
696
		|| return 1
697 698 699 700 701
	done
}

lang_subpkg() {
	default_lang_subpkg
702 703 704 705 706 707 708 709 710 711 712
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

713 714 715 716 717 718 719 720 721 722 723 724
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

725 726 727 728 729 730
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

731
prepare_metafiles() {
732
	getpkgver || return 1
733 734
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
735
	local dir=${subpkgdir:-$pkgdir}
736
	local pkg="$name-$pkgver-r$pkgrel.apk"
737
	local pkginfo="$controldir"/.PKGINFO
738
	local sub
Natanael Copa's avatar
Natanael Copa committed
739 740 741
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
742
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
743 744
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
745
	local parch="$CARCH"
746 747 748 749 750

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
751

752
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
753
	if [ -n "$FAKEROOTKEY" ]; then
754
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
755
	fi
756 757
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
758
pkgname = $name
759
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
760 761 762 763 764
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
765
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
766
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
767
EOF
768 769
	local i deps
	deps="$depends"
770
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
771 772
		for i in $install $triggers; do
			local s=${i%=*}
773
			[ "$name" != "${s%.*}" ] && continue
774
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
775 776 777 778 779
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
780 781
	fi
	
782 783 784 785 786 787 788 789 790 791
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

792
	if [ -n "$replaces_priority" ]; then
Natanael Copa's avatar
Natanael Copa committed
793
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
794 795
	fi

Natanael Copa's avatar
Natanael Copa committed
796
	for i in $license; do
797
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
798 799
	done
	for i in $replaces; do
800
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
801
	done
802
	for i in $deps; do
803
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
804 805
	done
	for i in $conflicts; do
806
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
807 808
	done
	for i in $provides; do
809
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
810
	done
811 812 813 814 815 816
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
817 818 819
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
820 821

	local metafiles=".PKGINFO"
822 823 824
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
825
		if [ "$n" != "$name" ]; then
826 827
			continue
		fi
828
		script=${f#$name}
829
		msg "Adding $script"
830
		cp "$startdir/$f" "$controldir/$script" || return 1
831
		chmod +x "$controldir/$script"
832 833
		metafiles="$metafiles $script"
	done
834
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
835
}
836

837 838
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
839
	local etype= soname= file= sover=
840
	[ "$arch" = "noarch" ] && return 0
841
	options_has "!tracedeps" && return 0
842
	# lets tell all the places we should look for .so files - all rpaths
843 844
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
845
		>"$controldir"/.rpaths
846 847 848 849 850 851 852
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
		warning "Redundat /usr/lib in rpath found"
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
853 854
}

855 856 857 858 859 860 861 862 863 864 865 866
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

867 868 869 870 871
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

872 873 874 875 876 877 878
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
879 880 881
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
882 883 884 885
	fi
	return 0
}

886
prepare_package() {
887
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
888
	stripbin
889 890
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
891 892 893 894 895 896 897 898
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

899 900 901 902 903 904 905 906 907 908 909 910 911 912 913 914 915 916 917 918 919 920 921
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

922 923 924 925
subpkg_provides() {
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

926 927 928
trace_apk_deps() {
	local name="$1"
	local dir="$2"
929
	local i= found= autodeps= deppkgs= missing=
930
	msg "Tracing dependencies..."
931 932 933
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
934
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
935 936 937 938
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
939
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
940 941
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
942
		msg "  added libgcc (due to libpthread)"
943
	fi
944
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
945 946 947 948 949
		# first check if its provided by same apkbuild
		grep -q -w "^$i" "$dir"/.provides-so 2>/dev/null && continue

		if subpkg_provides "$i" || $APK info -q -e "so:$i"; then
			autodeps="$autodeps so:$i"
950
		else
951
			missing="$missing $i"
952
		fi
953 954 955
	done

	# find all packages that holds the so files
956
	if [ -f "$dir"/.rpaths ]; then
957 958
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
959 960 961
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

962
	for found in $deppkgs; do
963
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
964 965 966
			warning "You can remove '$found' from depends"
			continue
		fi
967
		autodeps="$autodeps $found"
968
	done
969

970
	echo "# automatically detected:" >> "$dir"/.PKGINFO
971
	if [ -f "$dir"/.provides-so ]; then
972
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' "$dir"/.provides-so \
973
			>> "$dir"/.PKGINFO
974 975
	fi
	[ -z "$autodeps" ] && return 0
976
	for i in $autodeps; do
977 978
		echo "depend = $i"
	done | sort -u >> "$dir"/.PKGINFO
979 980
	# display all depends
	sed -n '/^depend =/s/depend = /\t/p' "$dir"/.PKGINFO >&2
981 982
}

983
find_scanelf_paths() {
984
	local datadir="$1"
Natanael Copa's avatar
Natanael Copa committed
985
	local paths="$datadir/lib:$datadir/usr/lib" i= rpaths=
986
	if [ -n "$ldpath" ]; then
987
		paths="$paths:$(echo "$ldpath" | sed "s|\(^\|:\)|\1$datadir|g")"
988 989
	fi
	# search in all rpaths
Natanael Copa's avatar
Natanael Copa committed
990 991
	for rpaths in "$pkgbasedir"/.control.*/.rpaths; do
		[ -f "$rpaths" ] || continue
992
		while read i; do
993 994 995 996
			local dir="${datadir}${i}"
			IFS=:
			if [ -d "$dir" ] && ! list_has "$dir" $paths; then
				paths="$paths:${dir}"
997
			fi
998
			unset IFS
Natanael Copa's avatar
Natanael Copa committed
999
		done < "$rpaths"
1000 1001 1002 1003 1004 1005
	done
	echo "$paths"
}

scan_shared_objects() {
	local name="$1" controldir="$2" datadir="$3"
1006
	local opt=
1007 1008 1009

	# allow spaces in paths
	IFS=:
1010
	set -- $(find_scanelf_paths "$datadir")
1011 1012
	unset IFS

1013 1014 1015
	if options_has "ldpath-recursive"; then
		opt="--recursive"
	fi
1016 1017
	msg "Scanning shared objects"
	# lets tell all the .so files this package provides in .provides-so
1018
	scanelf --nobanner --soname $opt "$@" | while read etype soname file; do
1019 1020
		# if soname field is missing, soname will be the filepath
		sover=0
1021 1022
		if [ -z "$file" ]; then
			file="$soname"
1023
			soname=${soname##*/}
1024 1025 1026 1027
		fi

		# we only want shared libs
		case $soname in
1028
		*.so|*.so.[0-9]*|*.c32);;
1029 1030 1031 1032 1033 1034 1035 1036 1037
		*) continue;;
		esac

		case "$file" in
		*.so.[0-9]*) sover=${file##*.so.};;
		*.so)
			# filter out sonames with version when file does not
			# have version
			case "$soname" in
1038 1039 1040 1041
			*.so.[0-9]*)
				if options_has "sover-namecheck"; then
					continue
				fi
1042 1043 1044
			esac
			;;
		esac
Natanael Copa's avatar
Natanael Copa committed
1045
		list_has "$soname" $somask && continue
1046
		echo "$soname $sover"
1047 1048 1049 1050 1051 1052 1053 1054 1055 1056
	# use awk to filter out dupes that has sover = 0
	done | awk '{ if (so[$1] == 0) so[$1] = $2; }
		END { for (i in so) print(i " " so[i]); }' \
		| sort -u > "$controldir"/.provides-so

	# verify that we dont have any duplicates
	local dupes="$(cut -d' ' -f1 "$controldir"/.provides-so | uniq -d)"
	if [ -n "$dupes" ]; then
		die  "provides multiple versions of same shared object: $dupes"
	fi
1057 1058 1059 1060 1061

	# now find the so dependencies
	scanelf --nobanner --recursive --needed "$datadir"  | tr ' ' ':' \
		| awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
		| sed 's:,:\n:g' | sort -u \
Natanael Copa's avatar
Natanael Copa committed
1062
	| while read soname; do
1063
		# only add files that are not self provided
Natanael Copa's avatar
Natanael Copa committed
1064 1065 1066
		grep -q -w "^$soname" "$controldir"/.provides-so \
			|| list_has "$soname" $somask \
			|| echo $soname
1067 1068 1069
	done > "$controldir"/.needs-so
}

1070 1071 1072 1073 1074 1075 1076 1077
# read size in bytes from stdin and show as human readable
human_size() {
	awk '{  split("B KB MB GB TB PB", type)
		for(i=5; y < 1; i--)
			y = $1 / (2**(10*i))
		printf("%.1f %s\n", y, type[i+2]) }'
}

1078
create_apks() {
1079
	local file= dir= name= ver= apk= datadir= size=
1080
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
1081
	mkdir -p "$PKGDEST"
1082 1083 1084 1085 1086 1087 1088 1089 1090
	if [ "$arch" != "noarch" ] && ! options_has "!tracedeps"; then
		for file in "$pkgbasedir"/.control.*/.PKGINFO; do
			dir="${file%/.PKGINFO}"
			name="$(pkginfo_val pkgname $file)"
			datadir="$pkgbasedir"/$name
			subpkgname=$name
			scan_shared_objects "$name" "$dir" "$datadir"
		done
	fi
1091
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
1092 1093 1094
		dir="${file%/.PKGINFO}"
		name=$(pkginfo_val pkgname $file)
		ver=$(pkginfo_val pkgver $file)
1095
		size=$(pkginfo_val size $file | human_size)
1096 1097 1098
		apk=$name-$ver.apk
		datadir="$pkgbasedir"/$name
		subpkgname=$name
1099 1100

		trace_apk_deps "$name" "$dir" || return 1
1101
		msg "Package size: ${size}"
1102
		msg "Compressing data..."
1103
		(
1104 1105
		cd "$datadir"
		# data.tar.gz
1106 1107 1108 1109 1110 1111
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
1112

1113
		msg "Create checksum..."
1114 1115 1116 1117 1118
		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
1119
		cd "$dir"
1120 1121
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
1122
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
1123

1124
		msg "Create $apk"
1125 1126
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
1127
		)
1128
	done
1129
	subpkgname=
1130 1131
}

1132
clean_abuildrepo() {
1133
	local apk
1134 1135 1136
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
1137
	for d in "$abuildrepo/$CARCH"; do
1138 1139
		[ -L "$d" ] && rm "$d"
	done
1140

1141 1142
	# remove broken links from abuildrepo
	for apk in *.apk */*.apk; do